1#!/bin/ksh -p
2#
3# CDDL HEADER START
4#
5# The contents of this file are subject to the terms of the
6# Common Development and Distribution License (the "License").
7# You may not use this file except in compliance with the License.
8#
9# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
10# or http://www.opensolaris.org/os/licensing.
11# See the License for the specific language governing permissions
12# and limitations under the License.
13#
14# When distributing Covered Code, include this CDDL HEADER in each
15# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
16# If applicable, add the following below this CDDL HEADER, with the
17# fields enclosed by brackets "[]" replaced with your own identifying
18# information: Portions Copyright [yyyy] [name of copyright owner]
19#
20# CDDL HEADER END
21#
22#
23# Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
24#
25# s10 boot script.
26#
27# The arguments to this script are the zone name and the zonepath.
28#
29
30. /usr/lib/brand/solaris10/common.ksh
31
32ZONENAME=$1
33ZONEPATH=$2
34ZONEROOT=$ZONEPATH/root
35
36w_missing=$(gettext "Warning: \"%s\" is not installed in the global zone")
37
38arch=`uname -p`
39if [ "$arch" = "i386" ]; then
40	ARCH32=i86
41        ARCH64=amd64
42elif [ "$arch" = "sparc" ]; then
43	# 32-bit SPARC not supported!
44	ARCH32=
45        ARCH64=sparcv9
46else
47        echo "Unsupported architecture: $arch"
48        exit 2
49fi
50
51#
52# Run the s10_support boot hook.
53#
54/usr/lib/brand/solaris10/s10_support boot $ZONENAME
55if (( $? != 0 )) ; then
56        exit 1
57fi
58
59BRANDDIR=/.SUNWnative/usr/lib/brand/solaris10;
60FILEDIR=$BRANDDIR/files;
61EXIT_CODE=1
62
63#
64# Replace the specified file in the booting zone with a wrapper script that
65# invokes s10_isaexec_wrapper.  This is a convenience function that reduces
66# clutter and code duplication.
67#
68# Parameters:
69#	$1	The full path of the file to replace (e.g., /sbin/ifconfig)
70#	$2	The access mode of the replacement file in hex (e.g., 0555)
71#	$3	The name of the replacement file's owner (e.g., root:bin)
72#
73# NOTE: The checks performed in the 'if' statement below are not generic: they
74# depend on the success of the zone filesystem structure validation performed
75# above to ensure that intermediate directories exist and aren't symlinks.
76#
77replace_with_native() {
78	path_dname=$ZONEROOT/`dirname $1`
79
80	[ ! -f $1 ] && printf "$w_missing" "$1"
81	if [ ! -h $path_dname -a -d $path_dname ]; then
82		safe_replace $ZONEROOT/$1 $BRANDDIR/s10_isaexec_wrapper $2 $3 \
83		    remove
84	fi
85}
86
87replace_with_native_py() {
88	path_dname=$ZONEROOT/`dirname $1`
89
90	[ ! -f $1 ] && printf "$w_missing" "$1"
91
92	if [ ! -h $path_dname -a -d $path_dname ]; then
93		safe_replace $ZONEROOT/$1 $BRANDDIR/s10_python_wrapper $2 $3 \
94		    remove
95	fi
96}
97
98wrap_with_native() {
99
100	[ ! -f $1 ] && printf "$w_missing" "$1"
101
102	safe_wrap $ZONEROOT/$1 $BRANDDIR/s10_isaexec_wrapper $2 $3
103}
104
105#
106# Before we boot we validate and fix, if necessary, the required files within
107# the zone.  These modifications can be lost if a patch is applied within the
108# zone, so we validate and fix the zone every time it boots.
109#
110
111#
112# BINARY REPLACEMENT
113#
114# This section of the boot script is responsible for replacing Solaris 10
115# binaries within the booting zone with Nevada binaries.  This is a two-step
116# process: First, the directory structure of the zone is validated to ensure
117# that binary replacement will proceed safely.  Second, Solaris 10 binaries
118# are replaced with Nevada binaries.
119#
120# Here's an example.  Suppose that you want to replace /usr/bin/zcat with the
121# Nevada /usr/bin/zcat binary.  Then you should do the following:
122#
123#	1.  Go to the section below labeled "STEP ONE" and add the following
124#	    two lines:
125#
126#		safe_dir /usr
127#		safe_dir /usr/bin
128#
129#	    These lines ensure that both /usr and /usr/bin are directories
130#	    within the booting zone that can be safely accessed by the global
131#	    zone.
132#	2.  Go to the section below labeled "STEP TWO" and add the following
133#	    line:
134#
135#		replace_with_native /usr/bin/zcat 0555 root:bin
136#
137# Details about the binary replacement procedure can be found in the Solaris 10
138# Containers Developer Guide.
139#
140
141#
142# STEP ONE
143#
144# Validate that the zone filesystem looks like we expect it to.
145#
146safe_dir /usr
147safe_dir /usr/lib
148safe_dir /usr/lib/autofs
149safe_dir /usr/lib/fs
150safe_dir /usr/lib/fs/autofs
151safe_dir /usr/lib/fs/ufs
152safe_dir /usr/lib/fs/zfs
153safe_dir /usr/lib/zfs
154safe_dir /usr/bin
155safe_dir /usr/sbin
156safe_dir /sbin
157
158#
159# STEP TWO
160#
161# Replace Solaris 10 binaries with Nevada binaries.
162#
163
164#
165# Replace various network-related programs with native wrappers.
166#
167replace_with_native /sbin/ifconfig 0555 root:bin
168
169#
170# PSARC 2009/306 removed the ND_SET/ND_GET ioctl's for modifying
171# IP/TCP/UDP/SCTP/ICMP tunables. If S10 ndd(1M) is used within an
172# S10 container, the kernel will return EINVAL. So we need this.
173#
174replace_with_native /usr/sbin/ndd 0555 root:bin
175
176#
177# Replace various ZFS-related programs with native wrappers.  These commands
178# either link with libzfs, dlopen libzfs or link with libraries that link
179# or dlopen libzfs.  Commands which fall into these categories but which can
180# only be used in the global zone are not wrapped.  The libdiskmgt dm_in_use
181# code uses libfs, but only the zpool_in_use() -> zpool_read_label() code path.
182# That code does not issue ioctls on /dev/zfs and does not need wrapping.
183#
184replace_with_native /sbin/zfs 0555 root:bin
185replace_with_native /sbin/zpool 0555 root:bin
186replace_with_native /usr/lib/fs/ufs/quota 0555 root:bin
187replace_with_native /usr/lib/fs/zfs/fstyp 0555 root:bin
188replace_with_native /usr/lib/zfs/availdevs 0555 root:bin
189replace_with_native /usr/sbin/df 0555 root:bin
190replace_with_native /usr/sbin/zstreamdump 0555 root:bin
191replace_with_native_py /usr/lib/zfs/pyzfs.py 0555 root:bin
192
193#
194# Replace automount and automountd with native wrappers.
195#
196replace_with_native /usr/lib/fs/autofs/automount 0555 root:bin
197replace_with_native /usr/lib/autofs/automountd 0555 root:bin
198
199#
200# The class-specific dispadmin(1M) and priocntl(1) binaries must be native
201# wrappers, and we must have all of the ones the native zone does.  This
202# allows new scheduling classes to appear without causing dispadmin and
203# priocntl to be unhappy.
204#
205rm -rf $ZONEROOT/usr/lib/class
206mkdir $ZONEROOT/usr/lib/class || exit 1
207
208find /usr/lib/class -type d -o -type f | while read x; do
209	[ -d $x ] && mkdir -p -m 755 $ZONEROOT$x
210	[ -f $x ] && wrap_with_native $x 0555 root:bin
211done
212
213#
214# END OF STEP TWO
215#
216
217#
218# Replace add_drv and rem_drv with /usr/bin/true so that pkgs/patches which
219# install or remove drivers will work.  NOTE: add_drv and rem_drv are hard
220# linked to isaexec so we want to remove the current executable and
221# then copy true so that we don't clobber isaexec.
222#
223filename=$ZONEROOT/usr/sbin/add_drv
224[ ! -f $filename.pre_p2v ] && safe_backup $filename $filename.pre_p2v
225rm -f $filename
226safe_copy $ZONEROOT/usr/bin/true $filename
227
228filename=$ZONEROOT/usr/sbin/rem_drv
229[ ! -f $filename.pre_p2v ] && safe_backup $filename $filename.pre_p2v
230rm -f $filename
231safe_copy $ZONEROOT/usr/bin/true $filename
232
233exit 0
234